var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var auth_exports = {};
__export(auth_exports, {
  CASAuth: () => CASAuth
});
module.exports = __toCommonJS(auth_exports);
var import_auth = require("@nocobase/auth");
var import_axios = __toESM(require("axios"));
class CASAuth extends import_auth.BaseAuth {
  constructor(config) {
    const { ctx } = config;
    super({
      ...config,
      userCollection: ctx.db.getCollection("users")
    });
  }
  getOptions() {
    const opts = this.options || {};
    return {
      ...opts,
      serviceUrl: `${opts.serviceDomain}${process.env.API_BASE_PATH}cas:service`
    };
  }
  getService(authenticator, appName, redirect) {
    const { serviceUrl } = this.getOptions();
    return encodeURIComponent(`${serviceUrl}?authenticator=${authenticator}&__appName=${appName}&redirect=${redirect}`);
  }
  async serviceValidate(ticket) {
    const { casUrl } = this.getOptions();
    const { authenticator, __appName: appName, redirect = "/admin" } = this.ctx.action.params;
    const service = this.getService(authenticator, appName, redirect);
    const url = `${casUrl}/serviceValidate?ticket=${ticket}&service=${service}`;
    this.ctx.logger.debug(`serviceValidate url: ${url}`, {
      module: "auth",
      submodule: "cas",
      method: "serviceValidate"
    });
    try {
      const res = await import_axios.default.get(url);
      return res;
    } catch (error) {
      throw new Error("CSA serviceValidate error: " + error.message);
    }
  }
  async validate() {
    var _a;
    const ctx = this.ctx;
    const { autoSignup } = this.getOptions();
    const { ticket } = ctx.action.params;
    if (!ticket) {
      throw new Error("Missing ticket");
    }
    const res = await this.serviceValidate(ticket);
    ctx.logger.debug(res == null ? void 0 : res.data, { module: "auth", submodule: "cas", method: "validate" });
    const pattern = /<(?:cas|sso):user>(.*?)<\/(?:cas|sso):user>/;
    const username = (_a = res == null ? void 0 : res.data.match(pattern)) == null ? void 0 : _a[1];
    if (!username) {
      throw new Error("Invalid ticket");
    }
    const authenticator = this.authenticator;
    let user = await authenticator.findUser(username);
    if (user) {
      return user;
    }
    user = await this.userRepository.findOne({
      filter: { username }
    });
    if (user) {
      await this.authenticator.addUser(user, {
        through: {
          uuid: username
        }
      });
      return user;
    }
    if (!autoSignup) {
      throw new Error("User not found");
    }
    if (!this.validateUsername(username)) {
      throw new Error(`Username must be 2-16 characters in length (excluding @.<>"'/)`);
    }
    return await authenticator.newUser(username, {
      username,
      nickname: username
    });
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CASAuth
});
